> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hookstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a destination

` POST /destinations `

Create a destination

## Servers

- ` https://hookstream.io/v1 ` — Production

## Authentication

The operation accepts these alternatives. Schemes within one alternative are required together.

### Alternative 1

- ` apiKey `: ` apiKey `

  - Credential: ` X-API-Key ` in ` header `

  - API key (format: hs_live_<64hex> or hs_test_<64hex>)

### Alternative 2

- ` cookieAuth `: ` apiKey `

  - Credential: ` better-auth.session_token ` in ` cookie `

  - Session cookie (browser auth)

## Request body (required)

Content type: ` application/json `

Request body

- ` value `: type ` object `

  - Required fields: ` name `, ` slug `

  - ` org_id `: type ` string `

  - ` env_id `: type ` string `

  - ` name `: type ` string `

  - ` slug `: type ` string `

  - ` url `: type ` string `

  - ` method `: type ` string `

  - ` headers `: type ` object `

  - ` timeout_ms `: type ` number `

  - ` auth_type `: type ` string `

  - ` auth_config `: type ` object `

  - ` type `: type ` string `

  - ` provider_config `: type ` object `

  - ` retry_enabled `: type ` boolean `

  - ` retry_max_attempts `: type ` number `

  - ` retry_backoff_type `: type ` string `

  - ` retry_intervals `: type ` array `

    - ` array item `: type ` number `

  - ` circuit_breaker_enabled `: type ` boolean `

  - ` circuit_breaker_threshold `: type ` number `

  - ` circuit_breaker_reset_ms `: type ` number `

## Responses

### ` 201 ` — Created destination

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` destination `

  - ` destination `: type ` object `; nullable

    - Required fields: ` id `, ` org_id `, ` env_id `, ` name `, ` slug `, ` url `, ` method `, ` headers `, ` timeout_ms `, ` auth_type `, ` auth_config `, ` status `, ` event_count `, ` last_delivery_at `, ` created_at `, ` updated_at `, ` retry_enabled `, ` retry_max_attempts `, ` retry_backoff_type `, ` retry_intervals `, ` circuit_breaker_enabled `, ` circuit_breaker_threshold `, ` circuit_breaker_reset_ms `, ` type `, ` provider_config `

    - ` id `: type ` string `

    - ` org_id `: type ` string `

    - ` env_id `: type ` string `

    - ` name `: type ` string `

    - ` slug `: type ` string `

    - ` url `: type ` string `

    - ` method `: type ` string `

    - ` headers `: type ` string `; nullable

    - ` timeout_ms `: type ` integer `

    - ` auth_type `: type ` string `

    - ` auth_config `: type ` string `; nullable

    - ` status `: type ` string `

    - ` event_count `: type ` integer `

    - ` last_delivery_at `: type ` string `; nullable

    - ` created_at `: type ` string `

    - ` updated_at `: type ` string `

    - ` retry_enabled `: type ` integer `; nullable

    - ` retry_max_attempts `: type ` integer `; nullable

    - ` retry_backoff_type `: type ` string `; nullable

    - ` retry_intervals `: type ` string `; nullable

    - ` circuit_breaker_enabled `: type ` integer `; nullable

    - ` circuit_breaker_threshold `: type ` integer `; nullable

    - ` circuit_breaker_reset_ms `: type ` integer `; nullable

    - ` type `: type ` string `

    - ` provider_config `: type ` string `; nullable

### ` 400 ` — Bad request

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

### ` 401 ` — Unauthorized

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string ` — Error message

### ` 403 ` — Forbidden — plan limit reached

Content type: ` application/json `

- ` value `: type ` object `

  - Required fields: ` error `

  - ` error `: type ` string `

  - ` upgrade_url `: type ` string `

## Request examples

### cURL

```curl
curl -X POST 'https://hookstream.io/v1/destinations' \
  -H 'Authorization: Bearer YOUR_API_TOKEN' \
  -H 'Content-Type: application/json' \
  -d '{
  "org_id": "string",
  "env_id": "string",
  "name": "string",
  "slug": "string",
  "url": "string",
  "method": "string",
  "headers": {},
  "timeout_ms": 0,
  "auth_type": "string",
  "auth_config": {},
  "type": "string",
  "provider_config": {},
  "retry_enabled": true,
  "retry_max_attempts": 0,
  "retry_backoff_type": "string",
  "retry_intervals": [
    0
  ],
  "circuit_breaker_enabled": true,
  "circuit_breaker_threshold": 0,
  "circuit_breaker_reset_ms": 0
}'
```

### JavaScript

```javascript
const response = await fetch('https://hookstream.io/v1/destinations', {
  method: 'POST',
  headers: {
      "Authorization": "Bearer YOUR_API_TOKEN",
      "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "org_id": "string",
    "env_id": "string",
    "name": "string",
    "slug": "string",
    "url": "string",
    "method": "string",
    "headers": {},
    "timeout_ms": 0,
    "auth_type": "string",
    "auth_config": {},
    "type": "string",
    "provider_config": {},
    "retry_enabled": true,
    "retry_max_attempts": 0,
    "retry_backoff_type": "string",
    "retry_intervals": [
      0
    ],
    "circuit_breaker_enabled": true,
    "circuit_breaker_threshold": 0,
    "circuit_breaker_reset_ms": 0
  })
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

headers = {
    'Authorization': 'Bearer YOUR_API_TOKEN'
}

response = requests.post('https://hookstream.io/v1/destinations', headers=headers, json={
  "org_id": "string",
  "env_id": "string",
  "name": "string",
  "slug": "string",
  "url": "string",
  "method": "string",
  "headers": {},
  "timeout_ms": 0,
  "auth_type": "string",
  "auth_config": {},
  "type": "string",
  "provider_config": {},
  "retry_enabled": true,
  "retry_max_attempts": 0,
  "retry_backoff_type": "string",
  "retry_intervals": [
    0
  ],
  "circuit_breaker_enabled": true,
  "circuit_breaker_threshold": 0,
  "circuit_breaker_reset_ms": 0
})
print(response.json())
```

### Go

```go
package main

import (
	"fmt"
	"io"
	"net/http"
	"strings"
)

func main() {
	body := strings.NewReader(`{
  "org_id": "string",
  "env_id": "string",
  "name": "string",
  "slug": "string",
  "url": "string",
  "method": "string",
  "headers": {},
  "timeout_ms": 0,
  "auth_type": "string",
  "auth_config": {},
  "type": "string",
  "provider_config": {},
  "retry_enabled": true,
  "retry_max_attempts": 0,
  "retry_backoff_type": "string",
  "retry_intervals": [
    0
  ],
  "circuit_breaker_enabled": true,
  "circuit_breaker_threshold": 0,
  "circuit_breaker_reset_ms": 0
}`)
	req, _ := http.NewRequest("POST", "https://hookstream.io/v1/destinations", body)
	req.Header.Set("Authorization", "Bearer YOUR_API_TOKEN")
	req.Header.Set("Content-Type", "application/json")

	resp, _ := http.DefaultClient.Do(req)
	defer resp.Body.Close()
	result, _ := io.ReadAll(resp.Body)
	fmt.Println(string(result))
}
```